#!/bin/sh
#
# script to enable time syncing on Mac OS X.

echo "University of Utah - Student Computing Labs"
echo "Network Time Server - time.utah.edu"
echo "Revised - 04.12.13"
echo

if [ `uname -s` != "Darwin" ]; then
  echo "error: script must only be run on Darwin systems"
  exit 1
fi

# set this to the NTP server hostname
TIMESERVER=time.utah.edu

# ntp.conf data
TIMECONFIG="$TIMESERVER minpoll 12 maxpoll 17"

# set proper values in NetInfo for ntpd (Mac OS X 10.0 and 10.1?)
niutil -create / /config/ntp
echo "Setting proper values in NetInfo for ntpd..."
echo " - Using:       Creating ntp file..."
echo " - Creating:    /config/ntp"
niutil -createprop / /config/ntp server $TIMECONFIG
echo " - Modifying:   Creating properties"
echo
niutil -resync /

# and set file data, just in case (Mac OS X 10.2?)  
echo "Updating network time server configuration..."
echo " - Using:     $TIMESERVER minpoll 12 maxpoll 17"
echo " - Modifying: /etc/ntp.conf"
echo
echo "server $TIMECONFIG" > /etc/ntp.conf

# enable timesyncing in startup preferences file
echo "Activating time synchronization..."
echo " - Using:      TIMESYNC=-YES-"
echo " - Modifying: /etc/hostconfig"
echo

if grep ^TIMESYNC /etc/hostconfig >/dev/null; then
       perl -i -ple 's/-NO-/-YES-/ if /^TIMESYNC/' /etc/hostconfig
       echo "Time server update & activation complete."
       echo
       echo "Note - Please test your configuration"
       echo " - Check:     System Preferences -> Date & Time"
       echo

else
       echo "TIMESYNC=-YES-" >> /etc/hostconfig
       echo "Time server update & activation complete."
       echo
       echo "NOTE, please test your configuration"
       echo " - Check:     System Preferences -> Date & Time"
       echo
fi

